import { ViewBase } from '../../libappbase/viewbase';
import { UIWaitSOP } from '../../libappsop/objectsop';
import { AppMP } from '../appmp';
import { FormProductionPlan } from '../forms/form.productionplan';
import { FormProductionPlanDetails } from '../forms/form.productionplandetails';

/**
 * Plan > Production Plan view which shows PISPIP having Non-Supplier quantity.
 */
export class ViewProductionPlan extends ViewBase implements UIWaitSOP {
  public readonly name = 'Production plan';
  public readonly viewPath = 'Plan > Production Plan';

  public formProductionPlan = new FormProductionPlan();
  public formProductionPlanDetails = new FormProductionPlanDetails();

  public async switchTo(): Promise<void> {
    const appMP = AppMP.getInstance();

    await appMP.abpPlan.click();
    await appMP.abpPlan.btnProductionPlan.click();

    await this.waitUILoaded();
  }

  public async waitUILoaded(): Promise<void> {
    await this.formProductionPlan.waitUntilPresent();
    await this.formProductionPlanDetails.waitUntilPresent();
  }
}
